#include<bits/stdc++.h>
using namespace std;

long long n;
const long long MAXN=1e7+10;
vector<pair<long long,long long>> g[MAXN];
long long used[MAXN];
long long p[MAXN];
long long sizet[MAXN];
long long k=1;
long long timep=0;
long long in[MAXN];
long long out[MAXN];
long long tree[4*MAXN];
long long lazy[4*MAXN];
void push_lazy(long long vr, long long l, long long r)
{
    if(lazy[vr]==0)return;
    tree[vr]=lazy[vr];
    if(l!=r)
    {
        lazy[2*vr]=lazy[vr];
        lazy[2*vr+1]=lazy[vr];
    }
    lazy[vr]=0;
}
void update(long long vr, long long l, long long r, long long L, long long R, long long val)
{
    if(r<L||l>R)return;
    push_lazy(vr,l,r);
    if(l>=L&&r<=R)
    {
        lazy[vr]=val;
        push_lazy(vr,l,r);
        return;
    }
    long long mid=(l+r)>>1;
    update(2*vr,l,mid,L,R,val);
    update(2*vr+1,mid+1,r,L,R,val);
}
int query(long long vr, long long l, long long r, long long x)
{
    push_lazy(vr,l,r);
    if(l==r)
    {
        return tree[vr];
    }
    long long mid=(l+r)>>1;
    if(x<=mid)return query(2*vr, l, mid, x);
    else return query(2*vr+1, mid+1, r, x);
}
void dfs(long long vr)
{
    in[vr]=++timep;
    used[vr]=1;
    p[vr]=k;
    for(long long i=0; i<g[vr].size(); i++)
    {
        if(!used[g[vr][i].first])dfs(g[vr][i].first);
        sizet[vr]+=sizet[g[vr][i].first];
    }
    sizet[vr]+=1;
    out[vr]=timep;
    //cout<<endl;
}
void init(int N, std::vector< std::pair<int,int> > e)
{

    n=N;
    for(long long i=0; i<e.size(); i++)
    {
        g[e[i].first].push_back({e[i].second,i});
        g[e[i].second].push_back({e[i].first,i});
    }
    for(long long i=1; i<=n; i++)
    {
        if(!used[i])
        {
            dfs(i);
            update(1,1,n,in[i],out[i],k);
            k++;
        }
    }
    /*for(long long i=1;i<n;i++)
    {
        cout<<in[i]<<" ";
    }
    cout<<endl;
    for(long long i=1;i<n;i++)
    {
        cout<<out[i]<<" ";
    }
    cout<<endl;*/
    return;
}

void close(int u,int v)
{
    /*for(long long i=1;i<=4*n;i++)
    {
        cout<<tree[i]<<" ";
    }
    cout<<endl;*/
    if(in[u]<in[v])update(1,1,n,in[v],out[v],k);
    else update(1,1,n,in[u],out[u],k);
    k++;/*for(long long i=1;i<=4*n;i++)
    {
        cout<<tree[i]<<" ";
    }
    cout<<endl;*/
    /*for(long long i=0;i<n;i++)
    {
        cout<<p[i]<<" ";
    }*/
    /* for(long long i=0;i<n;i++)
     {
         cout<<p[i]<<" ";
     }*/
}

bool question(int u,int v)
{
    /*for(long long i=1;i<=4*n;i++)
    {
        cout<<tree[i]<<" ";
    }
    cout<<endl;*/
   // cout<<in[u]<<in[v]<<endl;
    long long pu=query(1,1,n,in[u]);
   /* for(long long i=1;i<=4*n;i++)
    {
        cout<<tree[i]<<" ";
    }
    cout<<endl;*/
    long long pv=query(1,1,n,in[v]);

   // cout<<endl<<"//"<<pu<<" "<<pv<<endl;
    if(pu==pv)return 1;
    return 0;
}
