#include<bits/stdc++.h>

using namespace std;

const int MAXN = 1010;

int n;
int parent[MAXN];
vector <int> tree[MAXN];
void init(int N, std::vector< std::pair<int,int> > e)
{
    n = N;
    for (pair <int, int> k:e)
    {
        parent[k.second] = k.first;
        tree[k.first].push_back(k.second);
    }

    return;
}

bool isErased[MAXN][MAXN];
void close(int u,int v)
{
    isErased[u][v] = true;
}

bool DFS(int u, int v, vector <int> *graph, bool *used)
{
    if (u == v)
        return true;

    used[u] = true;
    for (int i:graph[u])
        if (!used[i])
            return DFS(i, v, graph, used);

    return false;
}
bool question(int u,int v)
{
    bool used[MAXN] = {false};
    vector <int> newGraph[MAXN];

    for (int i = 1; i <= n; i++)
    {
        for (int j:tree[i])
        {
            if (isErased[i][j])
                continue;

            newGraph[i].push_back(j);
        }
    }
    return DFS(u, v, newGraph, used);
}

/*
7 6
1 2
1 3
1 4
4 6
4 5
6 7
6
2 1 4
1 3 5
1 4 7
2 4 5
1 1 2
1 5 7
*/
