#include<bits/stdc++.h>

using namespace std;

const int MAXN = 1e6 + 50;
int n;

vector <int> Graph[MAXN];
pair <int, int> subtreeIndexes[MAXN];
int depth[MAXN], indexes[MAXN];

bool used[MAXN];
int t = 1, id = 1;
void ConstructTree(vector <int> *Graph, int currNode, int enteringTime, int d)
{
    indexes[currNode] = id++;
    used[currNode] = true;
    depth[currNode] = d;
    for (int i:Graph[currNode])
    {
        if (used[i])
            continue;

        t++;
        ConstructTree(Graph, i, t, d+1);
    }

    if (enteringTime == t)
        subtreeIndexes[currNode] = {-1, -1};
    else
        subtreeIndexes[currNode] = {enteringTime+1, t+1};
}

void init(int N, std::vector< std::pair<int,int> > e)
{
    n = N;
    for (auto k:e)
    {
        Graph[k.first].push_back(k.second);
        Graph[k.second].push_back(k.first);
    }

    ConstructTree(Graph, 1, t, 1);


    return;
}

set <int> Erased;
void close(int u,int v)
{
    if (depth[u] > depth[v])
        swap(u, v);

    Erased.insert(subtreeIndexes[u].first);
    Erased.insert(subtreeIndexes[u].second);
}

bool question(int u,int v)
{
    if (indexes[u] > indexes[v])
        swap(u, v);

    auto it = Erased.upper_bound(indexes[u]);

    if (it == Erased.end() || (*it) > indexes[v])
        return true;

    return false;
}

/*
7 6
1 2
1 3
1 4
4 6
4 5
6 7
6
2 1 4
1 3 5
1 4 7
2 4 5
1 1 2
1 5 7

7 6
1 2
2 3
3 4
4 5
5 6
6 7
10
1 3 5
1 2 4
2 3 4
2 5 4
1 4 5
1 3 4
1 2 8
1 1 5
1 1 3
1 1 2
*/
