#include<bits/stdc++.h>
using namespace std;
int parent[1000000];

map<pair<int,int>,pair<int,int>>translator;
class dsu
{
    public:
        dsu()
        {
            for(int i=0;i<1000000;i++)
            {
                parent[i]=i;
            }
        }
        //bool visited[100000]=false;
        void add_element(int a,int b)
        {
            if(parent[a]==a)
            {
                parent[a]=b;
                translator[{a,b}]={a,b};
                cout<<"a and b"<<a<<" "<<b<<endl;
                return;
            }
            if(parent[b]==b)
            {
                parent[b]=a;
                translator[{a,b}]={a,b};
                cout<<"b and a"<<b<<" "<<a<<endl;
                return;
            }
            int suppara=find_super_parent(a);
            int supparb=find_super_parent(b);
            cout<<"suppars:"<<suppara<<" "<<supparb<<endl;

            parent[suppara]=supparb;
            translator[{a,b}]={suppara,supparb};
        }
        void remove_con(int a,int b)
        {
            if(parent[a]==b)
            {
                parent[a]=a;
            }
            else if(parent[b]==a)
            {
                parent[b]=b;
            }
        }
        int find_super_parent(int a)
        {
            if(parent[a]!=a)
            {
                return find_super_parent(parent[a]);
            }
            else
                return a;
        }
        bool is_connected(int a,int b)
        {
            return find_super_parent(a)==find_super_parent(b);
        }
};
dsu maindsu;
void init(int N, std::vector< std::pair<int,int> > e){
    for(auto a:e)
    {
        maindsu.add_element(a.first,a.second);
    }
    return;
}

void close(int u,int v){
    auto ans=translator[{u,v}];
    maindsu.remove_con(ans.first,ans.second);
}

bool question(int u,int v){
    return maindsu.is_connected(u,v);
}
