#include<bits/stdc++.h>
using namespace std;
int parent[1000000];
class dsu
{
    public:
        dsu()
        {
            for(int i=0;i<1000000;i++)
            {
                parent[i]=i;
            }
        }
        void add_element(int a,int b)
        {
            if(parent[a]==a)
            {
                parent[a]=b;
                return;
            }
            if(parent[b]==b)
            {
                parent[b]=a;
                return;
            }

        }
        void remove_con(int a,int b)
        {
            if(parent[a]==b)
            {
                parent[a]=a;
            }
            else if(parent[b]==a)
            {
                parent[b]=b;
            }
        }
        int find_super_parent(int a,bool* visited)
        {
            if(visited[a])
            {
                return -1;
            }
            visited[a]=true;
            if(parent[a]!=a)
            {
                return find_super_parent(parent[a],visited);
            }
            else
                return a;
        }
        bool is_connected(int a,int b)
        {
            bool visited[100000]={false};
            int supera=find_super_parent(a,visited);
            int superb=find_super_parent(b,visited);
            if(supera==-1||superb==-1)
            {
                return true;
            }
            return supera==superb;
        }
};
dsu maindsu;
void init(int N, std::vector< std::pair<int,int> > e){
    for(auto a:e)
    {
        maindsu.add_element(a.first,a.second);
    }
    return;
}

void close(int u,int v){
    maindsu.remove_con(u,v);
}

bool question(int u,int v){
    return maindsu.is_connected(u,v);
}
