#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6;
const int INF = 1e9;
const int mod = 1e9 + 7;

int tree[MAX_N];

void update( int ind, int val ){
    while( ind < MAX_N ){
        tree[ind] += val;
        ind += ind&(-ind);
    }
}

int query( int ind ){
    int nas = 0;
    while( ind ){
        nas += tree[ind];
        ind -= ind&(-ind);
    }
    return nas;
}


std::vector<int> v[MAX_N];

int par[MAX_N];
std::vector<int> rem;


void dfs( int x, int p = -1 ){
    if( p != -1 ) update( x, 1 );
    for( auto j : v[x] ){
        if( j != p )dfs(j, x);
    }
}


int numCh[MAX_N];
bool viz[MAX_N];
int main (){

    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);


    int n;
    std::cin>>n;
    int st = -1;
    for( int i=1 ; i<=n ; i++ ){
        std::cin>>par[i];
        if( !par[i] ) st = i;
        numCh[par[i]]++;
        v[par[i]].push_back(i);
    }

    ll nas = 0;
    for( int i=1 ; i<=n ; i++ ){
        for( int i=0 ; i<MAX_N ; i++ ) tree[i] = 0;
        dfs( i );
        nas += query( i );
    }

    std::cout<<nas<<"\n";

    return 0;
}
