#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
const int MAXN = 1e5+9;
const int max1 = 5e3+9;
const int MAXLOG = 13;
int p[MAXN],ch[MAXN];
int jump[max1][MAXLOG];
int fath;
vector<int> adj[MAXN];
vector<int> a;
void dfs(int vr){
    a.push_back(vr);
    if(ch[vr]!=0) dfs(ch[vr]);
}
int n;
int ind[MAXN],tree[MAXN];
int query(int i){
    long long ans=0;
    while(i>0){
        ans+=tree[i];
        i-=(i&(-i));
    }
    return ans;
}
void update(int i,long long val){
    while(i<=n){
        tree[i]+=val;
        i+=(i&(-i));
    }
    return ;
}
bool used[MAXN];
int dep[MAXN];
void dfs2(int vr){
    used[vr]=1;
    for(auto to:adj[vr]){
        if(!used[to]){
            dep[to]=dep[vr]+1;
            dfs2(to);
        }
    }
}
bool fl;
int pars[MAXN];
int lca(int u,int v){
    int diff=dep[u]-dep[v];
    for(int log=MAXLOG-1;log>=0;log--){
        if((1<<log)&diff){
            u=jump[u][log];
        }
    }
    if(u==v) return u;
    for(int log=MAXLOG-1;log>=0;log--){
        if(jump[u][log]!=jump[v][log]){
            u=jump[u][log];
            v=jump[v][log];
        }
    }
    return p[u];
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>pars[i];
        adj[pars[i]].push_back(i);
        p[i]=pars[i];
        jump[i][0]=pars[i];
        ch[pars[i]]=i;
        if(pars[i]==0) fath=i;
    }
    sort(pars,pars+n);
    for(int i=1;i<=n;i++){
        if(pars[i]==pars[i+1]) fl=1;
    }
    long long ans=0;
    if(!fl){
        dfs(fath);
        for(int i=0;i<n;i++) ind[a[i]]=i+1;
        for(int i=n;i>=1;i--){
            ans+=query(ind[i]);
            update(ind[i],1);
        }
    }else{
        int x,y;
        dep[fath]=1;
        p[fath]=fath;
        jump[fath][0]=fath;
        dfs2(fath);
        for(int log=1;log<MAXLOG;log++){
            for(int i=1;i<=n;i++){
                jump[i][log]=jump[jump[i][log-1]][log-1];
            }
        }
        for(int i=1;i<=n;i++){
            for(int j=i+1;j<=n;j++){
                x=i; y=j;
                if(dep[i]<dep[j]) swap(x,y); // x e dulbokiq
                if(lca(x,y)==y && x<y) ans++;
            }
        }
    }
    cout<<ans<<"\n";
    return 0;
}
