#include<bits/stdc++.h>
using namespace std;
const int MAX_N = 1000007;
vector<pair<int, bool>> graph[MAX_N];
int n;
bool closed[MAX_N];
void init(int N, std::vector< std::pair<int,int> > e){
    for(int i = 0; i < e.size(); i++)
    {
        int from = e[i].first, to = e[i].second;
        from--;
        to--;
        graph[from].push_back({to, false});
        graph[to].push_back({from, false});
    }
    /*cout << endl << "Graph: " << endl;
    for(int i = 0; i < N; i++)
    {
        for(int j = 0; j < graph[i].size(); j++)
        {
            cout << "{" << graph[i][j].first << ", " << graph[i][j].second << "}";
        }
        cout << endl;
    }*/
    n = N;
    return;
}

void close(int u,int v){
    u--;
    v--;
    if(u > v)
    {
        swap(u, v);
    }
    closed[u] = true;
    for(int i = 0; i < graph[u].size(); i++)
    {
        if(graph[u][i].first == v)
        {
            //cout << "close: graph " << u << ", " << i << endl;
            graph[u][i].second = true;
            break;
        }
    }
    for(int i = 0; i < graph[v].size(); i++)
    {
        if(graph[v][i].first == u)
        {
            //cout << "close: graph " << v << ", " << i << endl;
            graph[v][i].second = true;
            break;
        }
    }
}

bool question(int u,int v){
    u--;
    v--;
    if(n > 1000)
    {
        if(u > v)
        {
            swap(u, v);
        }
        for(int i = u; i < v; i++)
        {
            if(closed[i])
            {
                return false;
            }
        }
        return true;
    }
    bool visited[n];
    for(int i = 0; i < n; i++)
    {
        visited[i] = false;
    }
    if(u == v)
    {
        return true;
    }
    queue<int> q;
    q.push(u);
    while(!q.empty())
    {
        int curr = q.front();
        q.pop();
        visited[curr] = true;
        for(int i = 0; i < graph[curr].size(); i++)
        {
            if(graph[curr][i].first == v && !graph[curr][i].second)
            {
                return true;
            }
            if(!visited[graph[curr][i].first] && !graph[curr][i].second)
            {
                /*if(u == 2)
                {
                    cout << "\npush: " << graph[curr][i].first << " " << graph[curr][i].second << endl;
                }*/
                q.push(graph[curr][i].first);
            }
        }
    }
    return false;
}
