#include <bits/stdc++.h>
using namespace std;
const int MAX_N = 1000000;
vector<int> tree[MAX_N];
int parent[MAX_N];
int n;
int root;
int bfs(int v)
{
    int res = 0;
    queue<int> q;
    q.push(v);
    bool visited[MAX_N] = {false};
    while(!q.empty())
    {
        int curr = q.front();
        q.pop();
        visited[curr] = true;
        if(v > curr)
        {
            res++;
        }
        for(int i = 0; i < tree[curr].size(); i++)
        {
            if(!visited[tree[curr][i]])
            {
                q.push(tree[curr][i]);
            }
        }
    }
    return res;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        a--;
        parent[i] = a;
        if(a != -1)
        {
            tree[a].push_back(i);
        }
        else
        {
            root = i;
        }
    }
    int res = 0;
    for(int i = 0; i < n; i++)
    {
        res += bfs(i);
    }
    cout << res;
    return 0;
}
