#include<bits/stdc++.h>
using namespace std;

vector<int> lines[1000001];
int group[1000001];
int n,groups=1;

void init(int N, std::vector< std::pair<int, int> > e){
    n=N;
    for(int i=0; i<e.size(); i++){
        lines[e[i].first].push_back(e[i].second);
        lines[e[i].second].push_back(e[i].first);
    }
}

void bfs(int s){
    queue<pair<int,int>> q;
    q.push({s,0});
    while(!q.empty()){
        int curr=q.front().first;
        int prev=q.front().second;
        q.pop();
        for(int i=0; i<lines[curr].size(); i++){
            if(lines[curr][i]!=prev){
                q.push({ lines[curr][i],curr });
            }
        }
        //printf("Change stop %d to group %d\n",curr,groups);
        group[curr]=groups;
    }
    groups++;
}

void close(int u,int v){
    for(int i=0;i<lines[u].size();i++){
        if(lines[u][i]==v) {
            lines[u].erase(lines[u].begin()+i);
            break;
        }
    } // disable u->v
    for(int i=0;i<lines[v].size();i++){
        if(lines[v][i]==u){
            lines[v].erase(lines[v].begin()+i);
            break;
        }
    } // disable v->u
    bfs(v);
}

bool question(int u,int v){
    return (group[u]==group[v]);
}
