#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 1e6 + 1;
vector<int> neighbours[MAXN];
int curr_color = 0;
int what[MAXN];
void color(int curr, int prev) {
    for (auto it : neighbours[curr]) {
        if (what[it] == what[curr] && it != prev) {
            color(it, curr);
        }
    }
    what[curr] = curr_color;
}
void init(int N, vector< pair<int, int> > e) {
    for (auto it : e) {
        neighbours[it.first].push_back(it.second);
        neighbours[it.second].push_back(it.first);
    }
    color(1, 0);
    curr_color++;
}
bool question(int u, int v) {
    return (what[u] == what[v]);
}
void close(int u, int v) {
    color(u, 0);
    curr_color++;
    color(v, 0);
    curr_color++;
}
//int main () {
//    int n;
//    cin >> n;
//    for (int i = 1; i < n; i++) {
//        int a, b;
//        cin >> a >> b;
//        neighbours[a].push_back(b);
//        neighbours[b].push_back(a);
//        con[a][b] = true;
//        con[b][a] = true;
//    }
//    while (1) {
//        bool q;
//        int u, v;
//        cin >> u >> v >> q;
//        if (q) {
//            close(u, v);
//        } else {
//            cout << question(u, v);
//        }
//    }
//}

