#include <iostream>
using namespace std;
const int INF = 1e9;
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, f, p, m;
    cin >> n >> f >> p >> m;
    long long ans = 0;
    int dist_prev = 0;
    int cost_best = INF;
    for (int i = 1; i <= n; i++) {
        int dist, time, cost;
        cin >> dist >> time >> cost;
        if (dist > p) {
            if (cost_best == INF) {
                cout << 1 / 0;
            }
            ans += cost_best * (dist - max(p, dist_prev));
        }
        if (cost < cost_best) {
            cost_best = cost;
        }
        dist_prev = dist;
    }
    ans += cost_best * (f - max(dist_prev, p));
    cout << 0 << ' ' << ans;
    return 0;
}

