#include <iostream>
#include <queue>
using namespace std;
const int INF = 1e9;
const int MAXN = 1e5 + 1;
long long dist[MAXN], time[MAXN], cost[MAXN];
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long e, n, f, p;
    long long money;
    cin >> n >> f >> p >> money;
    for (int i = 1; i <= n; i++) {
        cin >> dist[i] >> time[i] >> cost[i];
    }
    dist[0] = 0;
    long long l = -1, r = 1e18;
    long long ans = -1;
    while (1) {
        long long mid = (l + r) / 2;
        long long full_cost = 0;
        priority_queue< pair<long long, long long> > best = {};
        for (int i = 1; i <= n; i++) {
            int gone = dist[i] - max(p, dist[i - 1]);
            if (gone > 0 && best.empty()) {
                full_cost = -1;
                break;
            }
            while (gone > 0) {
                if (best.top().second > gone) {
                    pair<int, int> bub = {best.top().first, best.top().second - gone};
                    best.pop();
                    best.push(bub);
                    full_cost += -(best.top().first) * gone;
                    gone = 0;
                    break;
                } else {
                    gone -= best.top().second;
                    full_cost += (-best.top().first) * best.top().second;
                    best.pop();
                    if (best.empty()) {
                        full_cost = -1;
                        break;
                    }
                }
            }
            if (full_cost == -1) {
                full_cost = INF;
                break;
            }
            if (time[i] == 0) {
                best.push({-cost[i], INF});
            } else {
                if (mid / time[i] > INF) {
                    best.push({-cost[i], INF});
                } else {
                    best.push({-cost[i], mid / time[i]});
                }
            }
        }
        int gone = f - max(p, dist[n]);
        if (gone > 0 && best.empty()) {
            full_cost = -1;
            gone = 0;
        }
        while (gone > 0) {
            if (best.top().second > gone) {
                pair<int, int> bub = {best.top().first, best.top().second - gone};
                best.pop();
                best.push(bub);
                full_cost += (-best.top().first) * gone;
                gone = 0;
                if (best.top().second == 0) {
                    best.pop();
                }
                break;
            } else {
                gone -= best.top().second;
                full_cost += (-best.top().first) * best.top().second;
                best.pop();
                if (best.empty()) {
                    full_cost = INF;
                    break;
                }
            }
        }
        if (full_cost > money || full_cost == -1) {
            l = mid;
        } else {
            r = mid;
            ans = full_cost;
        }
        if (l + 1 == r) {
            cout << r << ' ' << ans;
            return 0;
        }
    }
}


