#include<iostream>
#include<vector>
using namespace std;
const int MAXN = 1e5+7;
int par[MAXN];
bool used[MAXN];
int xfind(int vr){
    if(par[vr]==vr) return vr;
    return xfind(par[vr]);
}
vector<int> susedi[MAXN];
int koren;
void dfs(int vr,int p){
    used[vr]=true;
    par[vr]=p;
    for(auto to:susedi[vr]){
        if(!used[to]){
            dfs(to,vr);
        }
    }
}
void init(int N, std::vector< std::pair<int,int> > e){
    for(auto [a,b]:e){
        susedi[b].push_back(a);
        susedi[a].push_back(b);
    }
    dfs(1,1);
    /*for(int i=1;i<=N;i++){
        cout<<par[i]<<" ";
    }*/
}

void close(int u,int v){
    if(par[v]==u){
        par[v]=v;
    }else{
        par[u]=u;
    }
}

bool question(int u,int v){
    while(par[v]!=v){
        v=par[v];
    }
    while(par[u]!=u){
        u=par[u];
    }
    if(u==v) return true;
    return false;
}

