#include<iostream>
#include<vector>
using namespace std;
const int MAXN = 1e5+7;
int par[MAXN];
bool used[MAXN];
int xfind(int vr){
    if(par[vr]==vr) return vr;
    return par[vr]=xfind(par[vr]);
}
vector<int> susedi[MAXN];
vector<int> s[MAXN];
int koren;
void dfs(int vr,int p){
    used[vr]=true;
    par[vr]=1;
    for(auto to:susedi[vr]){
        if(!used[to]){
            s[vr].push_back(to);
            dfs(to,vr);
        }
    }
}
void init(int N, std::vector< std::pair<int,int> > e){
    for(auto [a,b]:e){
        susedi[b].push_back(a);
        susedi[a].push_back(b);
    }
    dfs(1,1);
    /*for(int i=1;i<=N;i++){
        cout<<par[i]<<" ";
    }*/
}
void update(int vr,int newv,int oldv){
    par[vr]=newv;
    for(auto to:s[vr]){
        if(par[to]==oldv){
            update(to,newv,oldv);
        }
    }
}
void close(int u,int v){
    if(par[u]==v){
        par[u]=u;
        update(u,u,xfind(v));
    }else{
        update(v,v,xfind(u));
    }
}

bool question(int u,int v){
    if(xfind(u)==xfind(v)){
        return true;
    }
    return false;
}

