#include<bits/stdc++.h>
using namespace std;

const int maxn=1e3+32;
vector<int> nbrs[maxn];
bool ban[maxn][maxn];
bool vis[maxn];
int n;

bool bfs(int x, int y){
    for(int i=0; i<=n; i++){
        vis[i]=false;
    }

    vis[x]=true;

    queue<int> q;
    q.push(x);
    int curr;

    while(!q.empty()){
        curr=q.front();
        q.pop();
        for(int i=0; i<nbrs[curr].size(); i++){
            int next=nbrs[curr][i];
            if(!vis[next] and !ban[curr][next]){
                q.push(next);
                vis[next]=true;

                if(next==y){
                    return true;
                }
            }
        }
    }
    return false;
}

void init(int N, vector< pair<int,int> > e){
    for(int i=0; i<e.size(); i++){
        nbrs[e[i].first].push_back(e[i].second);
        nbrs[e[i].second].push_back(e[i].first);
        ban[e[i].second][e[i].first]=false;
        ban[e[i].second][e[i].first]=true;
    }
    for(int i=0; i<=N; i++){
        vis[i]=false;
    }
    n=N;


    return;
}

void close(int u,int v){
    ban[u][v]=true;
    ban[v][u]=true;

    return ;
}

bool question(int u,int v){
    if(bfs(u, v)){
        return true;
    }
    return false;
}

