#include<bits/stdc++.h>
using namespace std;

const int maxn=1e5+32;
vector<int> nbrs[maxn];
int krai[maxn], nach[maxn];
int n, bg=-1;
bool vis[maxn];

void dfs(int x){
    vis[x]=true;
    bg=max(bg, x);

    for(auto j: nbrs[x]){
        if(!vis[j]){
            //cerr<<"going from "<<x<<" to "<<j<<endl;
             dfs(j);
        }
    }
    return ;
}

void init(int N, vector< pair<int,int> > e){
    for(int i=0; i<e.size(); i++){
        nbrs[e[i].first].push_back(e[i].second);
        nbrs[e[i].second].push_back(e[i].first);

    }

    for(int i=0; i<=N; i++){
        vis[i]=false;
    }
    n=N;

    for(int i=0; i<=N; i++){
        if(!vis[i]){
            bg=-1;
            dfs(i);
            for(int x=i; x<=bg; x++){
                krai[x]=bg;
                nach[x]=i;
            }

            //cerr<<"comp of "<<i<<": "<<i<<" "<<bg<<endl;
        }
    }

    return;
}

void close(int u,int v){
    int bigger=max(u, v);
    int sm=min(v, u);

    krai[nach[sm]]=sm;
    nach[krai[bigger]]=bigger;
    krai[sm]=sm;
    nach[bigger]=bigger;

    //cerr<<"made krai["<<nach[sm]<<"]="<<krai[nach[sm]]<<" and nach["<<krai[bigger]<<"]="<<nach[krai[bigger]]<<endl;
    return ;
}

bool question(int u,int v){
    if(u==v){
        return true;
    }
    //cerr<<nach[u]<<" "<<nach[v]<<endl<<krai[u]<<" "<<krai[v]<<endl;

    if(nach[u]==nach[v] and krai[u]==krai[v]){
        return true;
    }
    return false;
}

