#include<bits/stdc++.h>
using namespace std;

int n,F,Y,lvl[1000001],p[1000001][20];
map<pair<int,int>,bool> m;
vector<int> v[1000001];

void dfs(int k){
    int i;
    lvl[k]=lvl[p[k][0]]+1;
    for(i=0;i<v[k].size();i++){
        if(lvl[v[k][i]]==0){
            p[v[k][i]][0]=k;
            dfs(v[k][i]);
        }
    }
}

void init(int N, vector<pair<int,int> > e){
    int i,j;
    for(i=0;i<e.size();i++){
        v[e[i].first].push_back(e[i].second);
        v[e[i].second].push_back(e[i].first);
    }
    dfs(1);
    for(i=1;i<20;i++){
        for(j=1;j<=N;j++) p[j][i]=p[p[j][i-1]][i-1];
    }
}

void close(int x, int y){
    m[{min(x,y),max(x,y)}]=1;
}

int jump(int k, int d){
    int s;
    while(d>0){
        if(d%2==1) k=p[k][s];
        s++;
        d/=2;
    }
    return k;
}

int flca(int x, int y){
    x=jump(x,lvl[x]-lvl[y]);
    if(x==y) return x;
    int i;
    for(i=19;i>=0;i--) if(p[x][i]!=p[y][i]){x=p[x][i]; y=p[y][i];}
    return p[x][0];
}

bool question(int x, int y){
    if(lvl[x]<lvl[y]) swap(x,y);
    int lca=flca(x,y);

    while(x!=lca){
        //if(m[{min(x,p[x][0]),max(x,p[x][0])}]) return 0;
        x=p[x][0];
    }
    while(y!=lca){
        //if(m[{min(y,p[y][0]),max(y,p[y][0])}]) return 0;
        y=p[y][0];
    }

    return 1;
}

/*
7 6
1 2
1 3
1 4
4 6
4 5
6 7
6
2 1 4
1 3 5
1 4 7
2 4 5
1 1 2
1 5 7
*/
