#include<iostream>
#include<vector>
#include<set>
using namespace std;
set<int> graph[1002];
bool dfs(bool isVisited[1002], int node, int d)
{
	if(isVisited[node])
	{
		return false;
	}
	
	if(node==d)
	{
		return true;
	}
	
	isVisited[node]=true;
	
		for(int child : graph[node])
		{
			if(dfs( isVisited, child ,d ))
			{
				return true;
			}
	 }
	
	return false;
}

void init(int N, vector< std::pair<int,int> > e){

	for(pair<int, int> node : e)
	{
		graph[node.first].insert(node.second);
	}
    return;
}

void close(int u,int v){
	graph[u].erase(v);
}

bool question(int u,int v){
	bool visited[1002];
    return  dfs(visited, u,v);
}