#include<iostream>
#include<vector>
#include<set>
#include <unordered_set>

using namespace std;
set<int> graph[100002];
void Print()
{
	 for(int i; i <3;i++)
		{
			cout<<i<<" - >";
	      for(int child : graph[i])
			{
			cout<<child<<" ";	
		    }
		    cout<<endl;
	}
}

bool dfs(unordered_set<int>  isVisited, int node, int d)
{
	if(node==d)
	{
		return true;
	}
	auto it= isVisited.find(node);
	if(it!=isVisited.cbegin())
	{
		return false;
	}
	
	isVisited.insert(node);
	
		for(auto child : graph[node])
		{
			bool f =dfs(isVisited, child ,d ); 
			//cout<<f<<endl;
			if(f==true)
			{
				return f;
			}
	    }
	
	return false;
}

void init(int N, vector< std::pair<int,int> > e){

	for(pair<int, int> node : e)
	{
		graph[node.first].insert(node.second);
		graph[node.second].insert(node.first);
	}
    return;
}

void close(int u,int v){
	graph[u].erase(v);
	graph[v].erase(u);
}

bool question(int u,int v){

	unordered_set<int> visited; 
	visited.clear();
    return  dfs(visited , u,v);
}