#include<iostream>
#include<vector>
#include<set>
#include <map>

using namespace std;
set<int> graph[100002];
map<int,bool> visited; 

void Print()
{
     for(int i; i <9;i++)
        {
            cout<<i<<" - >";
          for(int child : graph[i])
            {
            cout<<child<<" ";	
            }
            cout<<endl;
    }
}

bool dfs( int node, int d)
{
	if(d==node)
	{
		return true;
	}
    if(visited[node]==true)
    {
        return false;
    }
   
	visited[node]=true;
    for(int a : graph[node])
    {
    	
    	if(dfs( a, d)==true)
    	{
    		return true;
		}
	}
    return false;
}

void init(int N, vector< std::pair<int,int> > e){

    for(pair<int, int> node : e)
    {
        graph[node.first].insert(node.second);
        graph[node.second].insert(node.first);
    }
    return;
}

void close(int u,int v){
    graph[u].erase(v);
    graph[v].erase(u);
}

bool question(int u,int v){
    visited={};
    return  dfs( u,v);
}