#include<iostream>
#include<vector>
using namespace std;

vector <int> a[1000000];
bool used[1000000];
vector <int> conn;

void dfs(int start, int org)
{
    used[start] = true;
    if (start < org)
        conn.push_back(start);

    for (int i = 0; i < a[start].size(); i++)
        if (!used[a[start][i]])
            dfs(a[start][i], org);
}

int main()
{
    int n;
    cin >> n;

    int pos, ans = 0;

    for (int i = 1; i <= n; i++)
    {
        cin >> pos;

        if (pos != 0)
            a[pos].push_back(i);
    }

    for (int i = n; i > 1; i--)
    {
        if (a[i].size() != 0)
        {
            dfs(i, i);

            for (int j = 1; j <= n; j++)
                used[j] = 0;

            ans += conn.size();

            conn.clear();
        }
    }

    cout << ans << endl;
}