#include<iostream>
#include<vector>
using namespace std;

int n ;
bool mns[1002][1002] ;
bool used[1002] ;

bool C( int u , int v )
    {
    if ( mns[u][v] ) return true ;
    used[u] = true ;
    bool can = false ;
    for ( int i = 1 ; i <= n ; i++ )
        if ( mns[u][i] && !used[i] && C( i , v ) ) can = true ;
    return can ;
    }

void init(int N, std::vector< std::pair<int,int> > e)
{
    n = N ;
    for ( int i = 0 ; i < e.size() ; i++ )
        {
        mns[e[i].first][e[i].second] = 1 ;
        mns[e[i].second][e[i].first] = 1 ;
        }

    return ;
}

void close(int u,int v)
{
    mns[u][v] = 0 ;
    mns[v][u] = 0 ;
}

bool question(int u,int v)
{
    for ( int i = 1 ; i <= n ; i++ )
        used[i] = false ;
    return C( u , v ) ;
}
