#include<bits/stdc++.h>

using namespace std;

int n, sz;
int p[1000001];
set<pair<int, int>>edge;

int find_parent(int x)
{
    return (p[x]==x)?x:p[x]=find_parent(p[x]);
}

void buildDSU()
{
    for(int i=1;i<=n;i++)
    {
        p[i]=i;
    }
    for(auto it=edge.begin(); it!=edge.end(); it++)
    {
        int v1=it->first, v2=it->second;
        int pv1=find_parent(v1), pv2=find_parent(v2);
        if(pv1!=pv2)
        {
            p[pv1]=pv2;
        }
    }
}

void init(int N, vector<pair<int, int>>e)
{
    n=N;
    sz=e.size();
    for(int i=0;i<e.size();i++)
    {
        if(e[i].first>e[i].second)
        {
            swap(e[i].first, e[i].second);
        }
        edge.insert(e[i]);
    }
    buildDSU();
}

bool question(int u, int v)
{
    return find_parent(u)==find_parent(v);
}

void close(int u, int v)
{
    if(u>v)
    {
        swap(u, v);
    }
    edge.erase(edge.find({u, v}));
    buildDSU();
}

//int main(){ return 0;}
