#include<bits/stdc++.h>

using namespace std;

int n, sz;
int used[1000001];
unordered_set<int> nb[100001];
set<int>closed;
int subtask=2;


void dfs(int beg, int c)
{
    used[beg]=c;
    for(auto it=nb[beg].begin(); it!=nb[beg].end(); it++)
    {
        if(!used[*it])
        {
            dfs(*it, c);
        }
    }
}
void init(int N, vector<pair<int, int>>e)
{
    n=N;
    sz=e.size();
    for(int i=0; i<e.size(); i++)
    {
        int u=e[i].first;
        int v=e[i].second;
        if(u>v)swap(u, v);
        if(v-u>1)
        {
            subtask=1;
        }
        nb[u].insert(v);
        nb[v].insert(u);
    }
    if(subtask==2)
    {
        return;
    }
    int br=0;
    for(int i=1; i<=n; i++)
    {
        if(!used[i])
        {
            br++;
            dfs(i, br);
        }
    }
}
int brc=0;
bool question(int u, int v)
{
    if(u>v)swap(u, v);
    if(subtask==2)
    {
        auto it1=closed.upper_bound(u);
        return ((v<=(*it1))||it1==closed.end());
    }
    if(brc>0)
    {
        brc=0;
        int br=0;
        memset(used, 0, sizeof(used));
        for(int i=1; i<=n; i++)
        {
            if(!used[i])
            {
                br++;
                dfs(i, br);
            }
        }
    }
    return used[u]==used[v];
}

void close(int u, int v)
{
    if(u>v)swap(u, v);
    if(subtask==2)
    {
        closed.insert(u);
        return;
    }
    //memset(used, 0,  sizeof(used));
    nb[u].erase(nb[u].find(v));
    nb[v].erase(nb[v].find(u));
    brc++;
}


//int main(){ return 0;}
