#include<bits/stdc++.h>
using namespace std;

int n;
const int MAXN=1e7+10;
vector<pair<int,int>> g[MAXN];
int used[MAXN];
int p[MAXN];
bool edges[MAXN];
int sizet[MAXN];
int k=1;
map<pair<int,int>, int> mp;
int timep=0;
int in[MAXN];
int out[MAXN];
int tree[4*MAXN];
int lazy[4*MAXN];
void push_lazy(int vr, int l, int r)
{
    if(lazy[vr]==0)return;
    tree[vr]=lazy[vr];
    if(l!=r)
    {
        lazy[2*vr]=lazy[vr];
        lazy[2*vr+1]=lazy[vr];
    }
    lazy[vr]=0;
}
void update(int vr, int l, int r, int L, int R, int val)
{
    if(r<L||l>R)return;
    push_lazy(vr,l,r);
    if(l>=L&&r<=R)
    {
        lazy[vr]=val;
        push_lazy(vr,l,r);
        return;
    }
    int mid=(l+r)>>1;
    update(2*vr,l,mid,L,R,val);
    update(2*vr+1,mid+1,r,L,R,val);
}
int query(int vr, int l, int r, int x)
{
    push_lazy(vr,l,r);
    if(l==r)
    {
        return tree[vr];
    }
    int mid=(l+r)>>1;
    if(x<=mid)return query(2*vr, l, mid, x);
    else return query(2*vr+1, mid+1, r, x);
}
void dfs(int vr)
{
    in[vr]=++timep;
    used[vr]=1;
    p[vr]=k;
    for(int i=0; i<g[vr].size(); i++)
    {
        if(!used[g[vr][i].first]&&edges[g[vr][i].second]==0)dfs(g[vr][i].first);
        sizet[vr]+=sizet[g[vr][i].first];
    }
    sizet[vr]+=1;
    out[vr]=timep;
    //cout<<endl;
}
void init(int N, std::vector< std::pair<int,int> > e)
{

    n=N;
    for(int i=0; i<e.size(); i++)
    {
        if(e[i].first>e[i].second)swap(e[i].first,e[i].second);
        g[e[i].first].push_back({e[i].second,i});
        g[e[i].second].push_back({e[i].first,i});
        mp[ {e[i].first,e[i].second}]=i+1;
    }
    for(int i=1; i<=n; i++)
    {
        if(!used[i])
        {
            dfs(i);
            update(1,1,n,in[i],out[i],k);
            k++;
        }
    }
    /*for(int i=1;i<n;i++)
    {
        cout<<in[i]<<" ";
    }
    cout<<endl;
    for(int i=1;i<n;i++)
    {
        cout<<out[i]<<" ";
    }
    cout<<endl;*/
    return;
}

void close(int u,int v)
{
    /*for(int i=1;i<=4*n;i++)
    {
        cout<<tree[i]<<" ";
    }
    cout<<endl;*/
    if(u>v)swap(u,v);
    if(in[u]<in[v])update(1,1,n,in[v],out[v],k);
    else update(1,1,n,in[u],out[u],k);
    k++;/*for(int i=1;i<=4*n;i++)
    {
        cout<<tree[i]<<" ";
    }
    cout<<endl;*/
    /*for(int i=0;i<n;i++)
    {
        cout<<p[i]<<" ";
    }*/
    /* for(int i=0;i<n;i++)
     {
         cout<<p[i]<<" ";
     }*/
}

bool question(int u,int v)
{
    /*for(int i=1;i<=4*n;i++)
    {
        cout<<tree[i]<<" ";
    }
    cout<<endl;*/
   // cout<<in[u]<<in[v]<<endl;
    int pu=query(1,1,n,in[u]);
   /* for(int i=1;i<=4*n;i++)
    {
        cout<<tree[i]<<" ";
    }
    cout<<endl;*/
    int pv=query(1,1,n,in[v]);

    //cout<<endl<<"//"<<pu<<" "<<pv<<endl;
    if(pu==pv)return 1;
    return 0;
}
