#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e7+7;

vector <int> G[MAXN];
int n;

void init (int N, std::vector< std::pair<int,int> > e)
{
    n = N;
    for (auto x: e)
    {
        G[x.first].push_back(x.second);
        G[x.second].push_back(x.first);
    }
}

void close (int u, int v)
{
    for (int i = 0; i < G[u].size(); i++)
    {
        if (G[u][i] == v)
        {
            G[u].erase(G[u].begin() + i);
        }
    }
    for (int i = 0; i < G[v].size(); i++)
    {
        if (G[v][i] == u)
        {
            G[v].erase(G[v].begin() + i);
        }
    }
}

bool used[MAXN];
void dfs(int s)
{
    if (used[s]) return;
    used[s] = 1;
    for (int x: G[s])
        dfs(x);
}

bool question (int u, int v)
{
    for (int i = 0; i <= n; i++)
        used[i] = 0;

    dfs(u);

    return used[v];
}
