#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e7+7;
int n;
vector <int> G[MAXN];


int tree[4*MAXN];

void update(int ind, int val)
{
    while (ind <= n)
    {
        tree[ind] += val;
        ind += (ind & -ind);
    }
}

int query(int ind)
{
    int ret = 0;
    while (ind >= 1)
    {
        ret += tree[ind];
        ind -= (ind & -ind);
    }
    return ret;
}

int query(int s, int e)
{
    return query(e) - query(s-1);
}



void init (int N, std::vector< std::pair<int,int> > e)
{
    n = N;
    for (int i = 1; i <= n; i++)
        update(i, 1);
}

void close (int u, int v)
{
    if (u > v) swap(u, v);
    update(v, -1);
}


bool question (int u, int v)
{
    if (u > v) swap(u, v);
    return query(u+1, v) >= v-u+1;
}
