#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 1e6+6;
int p[MAXN];
int n, r;
long long ans;

vector <int> G[MAXN];
vector <int> vis; //

set <int> st;
vector <int> v(1);

int tree[4*MAXN];

void update(int ind, int val)
{
    while (ind <= n)
    {
        tree[ind] += val;
        ind += (ind & -ind);
    }
}

int query(int ind)
{
    int ret = 0;
    while (ind >= 1)
    {
//        cerr << "*" << tree[ind] << endl;
        ret += tree[ind];
        ind -= (ind & -ind);
    }
    return ret;
}

int query(int s, int e)
{
    return query(e) - query(s-1);
}

void dfs(int s)
{
    ans += query(s, n);

    update(s, +1);
    for (int x: G[s])
        dfs(x);

    update(s, -1);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        cin >> p[i];
        G[p[i]].push_back(i);
        if (!p[i]) r = i;
    }

    dfs(r);

    cout << ans << endl;

    return 0;
}
/**
7
7 4 6 0 1 5 2

10
*/
