#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 1e5+5;
long long N, F, P, C;

struct Station
{
    long long x, t, c;
    Station () {};
    Station (int _x, int _t, int _c)
    {
        x = _x; t = _t; c = _c;
    }
};

Station a[MAXN];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> N >> F >> P >> C;
    for (int i = 1; i <= N; i++)
    {
        int x, t, c;
        cin >> x >> t >> c;
        a[i] = Station(x, t, c);
    }
    a[N+1] = Station(F, 0, 0);

    long long S = 0;

    long long curr = 1;

    for (int i = 2; i <= N+1; i++)
    {
        if (a[i].c < a[curr].c)
        {
            S += max(0LL, (a[i].x - P + 1) * a[curr].c);
            P = a[i].x;
            curr = i;
        }
    }

    cout << 0 << " " << S << endl;

    return 0;
}
/**
4 5 1 6
1 0 1
2 0 2
3 0 3
4 0 1


*/
