#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long MAXN = 100005;
long long n,num,inversions = 0,children[MAXN],score[MAXN];
vector<long long> v[MAXN];

void calcChildren(int key)
{
    if(v[key].size()==0){
        children[key] = 0;
        return;
    }
    if(children[key]!=0)return;
    long long cou = 0;
    for(int i = 0; i < v[key].size();i++){
        calcChildren(v[key][i]);
        cou += children[v[key][i]] + 1;
    }
    children[key] = cou;
    return ;
}
int scoredfs(int key, int parent)
{
    long long cou = 0;
    if(children[key]==0){
        if(key < parent)return 1;
        else return 0;
    }
    if(key > parent){
        for(long long i = 0; i < v[key].size();i++){
            cou += scoredfs(v[key][i],parent);
        }
        return cou;
    }
    if(key < parent && score[key]==children[key]){
        return score[key] + 1;
    }
    if(key < parent && score[key]!=children[key]){
        for(long long i = 0; i < v[key].size();i++){
            cou += scoredfs(v[key][i],parent);
        }
        return cou + 1;
    }
}
void calcScore(int key)
{
    if(children[key]==0){
        score[key] = 0;
        return;
    }
    if(score[key]!=0)return ;
    long long cou = 0;
    for(int i = 0; i < v[key].size();i++){
        cou += scoredfs(v[key][i], key);
    }
    score[key] = cou;
    return ;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n;
    for(long long i = 1; i <= n; i++){
        cin >> num;
        v[num].push_back(i);
    }
    /*
    for(int i = 0; i <= n; i++){
        cout << i << endl;
        for(long long j = 0; j < v[i].size(); j++){
            cout << v[i][j] << " ";
        }
        cout << endl;
        cout << endl;
    }
    */
    calcChildren(v[0][0]);
    for(int i = 1; i <= n; i++){
    calcScore(i);
    inversions += score[i];
    }

    cout << inversions << endl;
    return 0;
}


