#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long MAXN = 100003;
long n,a[MAXN],r[MAXN],num,last,inversions = 0,cop,pos;
vector<long long> sorted;
vector<long long> v[MAXN];
long long children[MAXN],score[MAXN];
int findPost(int x)
{
    int l = 0, r = sorted.size(),m;
    while(l < r)
    {
        m = (l + r)/2;
        if(sorted[m] < x)
        {
            l = m + 1;
        }
        else
        {
            r = m;
        }
    }
    return r;
}
void calcChildren(int key)
{
    if(v[key].size()==0)
    {
        children[key] = 0;
        return;
    }
    if(children[key]!=0)return;
    long long cou = 0;
    for(int i = 0; i < v[key].size(); i++)
    {
        calcChildren(v[key][i]);
        cou += children[v[key][i]] + 1;
    }
    children[key] = cou;
    return ;
}
int scoredfs(int key, int parent)
{
    long long cou = 0;
    if(children[key]==0)
    {
        if(key < parent)return 1;
        else return 0;
    }
    if(key > parent)
    {
        for(long long i = 0; i < v[key].size(); i++)
        {
            cou += scoredfs(v[key][i],parent);
        }
        return cou;
    }
    if(key < parent && score[key]==children[key])
    {
        return score[key] + 1;
    }
    if(key < parent && score[key]!=children[key])
    {
        for(long long i = 0; i < v[key].size(); i++)
        {
            cou += scoredfs(v[key][i],parent);
        }
        return cou + 1;
    }
}
void calcScore(int key)
{
    if(children[key]==0)
    {
        score[key] = 0;
        return;
    }
    if(score[key]!=0)return ;
    long long cou = 0;
    for(int i = 0; i < v[key].size(); i++)
    {
        cou += scoredfs(v[key][i], key);
    }
    score[key] = cou;
    return ;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n;
    if(n >= 5000)
    {
        for(long long i = 1; i <= n; i++)
        {
            cin >> num;
            r[num] = i;
        }
        last = 0;
        for(long long i = 1; i <= n; i++)
        {
            a[i] = r[last];
            last = r[last];
        }

        sorted.push_back(a[n]);
        for(long long j = n - 1; j>= 1; j--)
        {
            pos  = findPost(a[j]);
            inversions+=pos;
            sorted.insert(sorted.begin() + pos,a[j]);

        }
        cout << inversions << endl;
    }
    else
    {
        for(long long i = 1; i <= n; i++)
        {
            cin >> num;
            v[num].push_back(i);
        }
        /*
        for(int i = 0; i <= n; i++){
            cout << i << endl;
            for(long long j = 0; j < v[i].size(); j++){
                cout << v[i][j] << " ";
            }
            cout << endl;
            cout << endl;
        }
        */
        calcChildren(v[0][0]);
        for(int i = 1; i <= n; i++)
        {
            calcScore(i);
            inversions += score[i];
        }

        cout << inversions << endl;
    }
    return 0;
}
