#include<iostream>
#include<vector>
#define MAXN 2000002
long long n, a, b, bit[4 * MAXN], n2, p[MAXN];
std::vector<std::pair<int, bool> > M[MAXN];
bool flag = 1;
int par(int v)
{
    //cout<<v<<" "<<p[v]<<endl;
    if(p[v] == 0) return v;
    return p[v] = par(p[v]);
}
void add(int u, int v)
{
    int p1 = par(u);
    int p2 = par(v);
    if(p1 != p2) p[p1] = p2;
}
bool check(int u, int v)
{
    return par(v) == par(u);
}
void del()
{
    for(int i = 1; i<=n2; i ++) p[i] = 0;
}
void build()
{
    for(int i = 1; i <= n2; i ++) for(std::pair<int, int> p : M[i])
    {
        if(p.second) add(i, p.first);
    }
}
void rem(int u, int v)
{
    for(int i = 0; i < M[v].size(); i ++)
    {
        if(M[v][i].first == u && M[v][i].second) M[v][i].second = 0;
    }
    for(int i = 0; i < M[u].size(); i ++)
    {
        if(M[u][i].first == v && M[u][i].second) M[u][i].second = 0;
    }
    del();
    build();
}
void addD(long long ind, long long a)
{
    for(; ind <= n; ind += ind & (-ind))
    {
        bit[ind] += a;
    }
}
long long query(long long ind)
{
    long long ans = 0;
    for(; ind > 0; ind -= ind & (-ind))
    {
        ans += bit[ind];
    }
    return ans;
}
void init(int N, std::vector< std::pair<int,int> > e)
{
    n = 2 * N;
    n2 = N;
    for(int i = 0; i < e.size() ; i ++)
    {
        M[e[i].first].push_back({e[i].second, 1});
        M[e[i].second].push_back({e[i].first, 1});
        if(abs(e[i].first - e[i].second) != 1) flag = 0;
    }
    //std::cout<<flag<<std::endl;
    return;
}

void close(int u,int v)
{
    if(flag) addD(u + v, 1);
    else rem(u, v);
}

bool question(int u,int v)
{
    if(flag)
    {
        if(u > v) std::swap(u, v);
        return (query(2 * v - 1) - query(2 * u)) <= 0;
    }
    else
    {
        return check(u, v);
    }

}
