#include<bits/stdc++.h>

using namespace std;

const int MAXN = 1e6 + 50;
int n;

vector <int> Graph[MAXN];
pair <int, int> subtreeIndexes[MAXN];
int depth[MAXN], indexes[MAXN];

bool used[MAXN];
int t = 1, id = 1;
void ConstructTree(vector <int> *Graph, int currNode, int enteringTime, int d)
{
    indexes[currNode] = id++;
    used[currNode] = true;
    depth[currNode] = d;
    for (int i:Graph[currNode])
    {
        if (used[i])
            continue;

        t++;
        ConstructTree(Graph, i, t, d+1);
    }


    subtreeIndexes[currNode] = {enteringTime, t+1};
}

void init(int N, std::vector< std::pair<int,int> > e)
{
    n = N;
    for (auto k:e)
    {
        Graph[k.first].push_back(k.second);
        Graph[k.second].push_back(k.first);
    }

    ConstructTree(Graph, 1, t, 1);

    //for (int i = 1; i <= N; i++)
    //{
        //cout << i << " -> " << subtreeIndexes[i].first << " " << subtreeIndexes[i].second << " " << depth[i] << " " << indexes[i] << endl;
   // }


    return;
}

set <int> Erased;
void close(int u,int v)
{
    if (depth[u] < depth[v])
        swap(u, v);

       // cout << "+ " << subtreeIndexes[u].first << " " << subtreeIndexes[v].second << endl;
    Erased.insert(subtreeIndexes[u].first);
    Erased.insert(subtreeIndexes[u].second);
}

bool question(int u,int v)
{
    u = indexes[u];
    v = indexes[v];

   // cout << " ? " << u << " " << v << endl;
    if (u > v)
        swap(u, v);

    auto it = Erased.upper_bound(u);

    if (it == Erased.end() || (*it) > v)
        return true;

    return false;
}

/*
7 6
1 2
1 3
1 4
4 6
4 5
6 7
6
2 1 4
1 3 5
1 4 7
2 4 5
1 1 2
1 5 7

7 6
1 2
2 3
3 4
4 5
5 6
6 7
10
1 3 5
1 2 4
2 3 4
2 5 4
1 4 5
1 3 4
1 2 8
1 1 5
1 1 3
1 1 2
*/
