#include <bits/stdc++.h>

/*
#pragma GCC optimize("O3, unroll-loops")
#pragma GCC target("bmi, avx2")
*/
#define endl '\n'

using namespace std;

const int64_t MAXN = 2e5;
struct Station
{
    int64_t x, t, c;
    Station(){}
    Station(int64_t x, int64_t t, int64_t c)
        :x(x), t(t), c(c){}
};

int64_t N, F, POri, C;
Station stations[MAXN];
int64_t br[MAXN];

pair <bool, int64_t> Check(int64_t T)
{
    int64_t P = POri;
    for (int64_t i = 0; i < N; i++)
    {
        br[i] = T / stations[i].t;
    }

    priority_queue <pair <int64_t, int64_t>,
                    vector <pair <int64_t, int64_t>>,
                    greater <pair <int64_t, int64_t>>> pq;

    int64_t cost = 0, change, prev = 0;
    pair <int64_t, int64_t> top;
    for (int64_t i = 0; i < N; i++)
    {
        P -= (stations[i].x-prev);

        while (P < 0 && !pq.empty())
        {
            top = pq.top();
            pq.pop();

            change = min(-P, top.second);
            P += change;
            cost += change*top.first;

            if (top.second - change > 0)
                pq.push({top.first, top.second-change});
        }

        prev = stations[i].x;
        pq.push({stations[i].c, br[i]});
    }

    if (P < 0)
        return {false, 1e18};

    return {cost <= C, cost};
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> N >> F >> POri >> C;

    for (int64_t i = 0; i < N; i++)
    {
        cin >> stations[i].x >> stations[i].t >> stations[i].c;
    }

    cout << Check(1e18).first << endl;
   /* if (POri >= F)
    {
        cout << 0 << " " << 0 << endl;
        return 0;
    }

    stations[N].x = F;
    stations[N].t = 0;
    stations[N].c = 0;

    int64_t l = 1, r = 1e18;
    pair <int64_t, int64_t> res, T = {-1, -1};

    while (l <= r)
    {
        int64_t mid = (l+r)/2;
        res = Check(mid);

        if (res.first)
        {
            T = {mid, res.second};
            r = mid-1;
        }

        else
        {
            l = mid+1;
        }
    }

    cout << T.first << " " << T.second << endl;*/

    return 0;
}
