#include<iostream>
#include<vector>
using namespace std;
const int MAXN = 1e7;
vector<int> a[MAXN];
int p[MAXN],dep[MAXN];
int n;
bool fl;
bool used[MAXN];
vector<int> closed;
void dfs(int vr){
    used[vr]=1;
    for(auto to:a[vr]){
        if(!used[to]){
            dep[to]=dep[vr]+1;
            dfs(to);
            p[to]=vr;
        }
    }
}
void init(int N, std::vector< std::pair<int,int> > e){
    n=N;
    if(N>1000) fl=1;
    for(auto [x,y]:e){
        x--; y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    dep[0]=1;
    p[0]=0;
    dfs(0);
    return;
}

void close(int u,int v){
    u--; v--;
    if(fl){
        if(u>v) swap(u,v);
        closed.push_back(u);
    }else{
        if(dep[u]<dep[v]) p[v]=v;
        else p[u]=u;
    }
}
int xfind(int x){
    if(x==p[x]) return x;
    return xfind(p[x]);
}
bool question(int u,int v){
    u--; v--;
    // cout<<u<<" "<<v<<"\n";
    // cout<<dep[u]<<" "<<dep[v]<<"\n";
    if(u>v) swap(u,v);
    if(fl){
        for(auto t:closed){
            if(t>=u && t<v) return 0;
        }
        return 1;
    }
    return xfind(u)==xfind(v);
}
