#include<iostream>
#include<vector>
using namespace std;
const int MAXN = 1e5+9;
const int MAXLOG = 18;
vector<int> a[MAXN];
vector<int> child[MAXN];
int dep[MAXN];
int jump[MAXN][MAXLOG];
int LOG[MAXN],lg;
int n;
bool used[MAXN];
vector<int> closed;
void dfs(int vr){
    used[vr]=1;
    for(auto to:a[vr]){
        if(!used[to]){
            dep[to]=dep[vr]+1;
            jump[to][0]=vr;
            child[vr].push_back(to);
            dfs(to);
        }
    }
}
bool pow2(int x){
    if(x%2==1){
        if(x==1) return 1;
        return 0;
    }
    return pow2(x/2);
}
void init(int N, std::vector< std::pair<int,int> > e){
    n=N;
    lg=0;
    for(int i=1;i<n;i++){
        LOG[i]=lg;
        if(pow2(i)) lg++;
    }
    for(auto [x,y]:e){
        x--; y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    dep[0]=1;
    jump[0][0]=0;
    dfs(0);
    for(int log=1;log<MAXLOG;log++){
        for(int i=0;i<n;i++){
            jump[i][log]=jump[jump[i][log-1]][log-1];
        }
    }
    return;
}
void closing(int up,int start,int dep){
    for(auto to:child[start]){
        for(int i=LOG[dep];i<MAXLOG;i++){
            jump[to][i]=up;
        }
        closing(up,to,dep+1);
    }
    return;
}
void close(int u,int v){
    u--; v--;
    if(dep[u]<dep[v]) swap(u,v); // u e dulbokiq
    for(int i=0;i<MAXLOG;i++) jump[u][i]=u;
    closing(u,u,1);
}
bool question(int u,int v){
    if(u==v) return 1;
    u--; v--;
    if(dep[u]<dep[v]) swap(u,v); /// u e dulbokiq
    int diff=dep[u]-dep[v];
    for(int log=MAXLOG;log>=0;log--){
        if((1<<log)&diff){
            u=jump[u][log];
        }
    }
    if(u==v) return 1;
    for(int log=MAXLOG;log>=0;log--){
        if((jump[u][log]==u && jump[v][log]!=v) || (jump[u][log]!=u && jump[v][log]==v)) return 0;
        if(jump[u][log]!=jump[v][log]){
            u=jump[u][log];
            v=jump[v][log];
        }
    }
    return jump[u][0]==jump[v][0];
}
