#include <bits/stdc++.h>
using namespace std;
const int MAX_N = 1000000;
vector<int> tree[MAX_N];
int parent[MAX_N];
int n;
int root;
int biggest[MAX_N];
int results[MAX_N];
vector<int> topSort;
int inVerticies[MAX_N];
bool calculated[MAX_N];
int prefixMax[MAX_N];
int bfs(int v)
{
    int res = 0;
    queue<int> q;
    for(int i = 0; i < tree[v].size(); i++)
    {
        if(biggest[tree[v][i]] <= v && calculated[tree[v][i]])
        {
            res += results[tree[v][i]];
            if(v >= tree[v][i])
            {
                res++;
            }
        }
        else
        {
            q.push(tree[v][i]);
        }
    }
    bool visited[MAX_N] = {false};
    while(!q.empty())
    {
        int curr = q.front();
        q.pop();
        visited[curr] = true;
        if(curr > biggest[v])
        {
            biggest[v] = curr;
        }
        if(v >= curr)
        {
            res++;
        }
        for(int i = 0; i < tree[curr].size(); i++)
        {
            if(!visited[tree[curr][i]])
            {
                q.push(tree[curr][i]);
            }
        }
    }
    return res;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        a--;
        parent[i] = a;
        if(a != -1)
        {
            inVerticies[i]++;
            tree[a].push_back(i);
        }
        else
        {
            root = i;
        }
    }
    int res = 0;
    queue<int> q;
    q.push(root);
    while(!q.empty())
    {
        int curr = q.front();
        q.pop();
        topSort.push_back(curr);
        for(int i = 0; i < tree[curr].size(); i++)
        {
            inVerticies[tree[curr][i]]--;
            if(inVerticies[tree[curr][i]] == 0)
            {
                q.push(tree[curr][i]);
            }
        }
    }
    if(n <= 5000)
    {
        for(int i = 0; i < topSort.size(); i++)
        {
            res += bfs(topSort[i]);
            calculated[topSort[i]] = true;
        }
    }
    else
    {
        for(int i = topSort.size() - 1; i >= 0; i--)
        {
            if(i == topSort.size() - 1)
            {
                prefixMax[i] = topSort[i];
            }
            else
            {
                prefixMax[i] = max(topSort[i], prefixMax[i + 1]);
            }
        }
        for(int i = 0; i < topSort.size(); i++)
        {
            if(topSort[i] > prefixMax[i + 1])
            {
                res += topSort.size() - i - 1;
            }
            else
            {
                for(int j = i; j < topSort.size(); j++)
                {
                    if(j < topSort.size() - 1)
                    {
                        if(topSort[i] > prefixMax[j + 1])
                        {
                            res += topSort.size() - j - 1;
                            break;
                        }
                    }
                    if(topSort[i] > topSort[j])
                    {
                        res++;
                    }
                }
            }
        }
    }
    cout << res;
    return 0;
}
