#include <bits/stdc++.h>
using namespace std;
int n, f, p, c;
struct station
{
    int x;
    int t;
    int c;
};
const int MAX_N = 100000;
station stations[MAX_N];
pair<int, int> minTime(int currKm, int currMoney, int currGas, int waitingTime, int currStation)
{
    if(currGas < 0)
    {
        return {10000000, c - currMoney};
    }
    if(currGas + currKm >= f)
    {
        return {waitingTime, c - currMoney};
    }
    pair<int, int> best = {10000000, c - currMoney};
    if(currStation < n)
    {
        for(int i = 0; true; i++)
        {
            if(currMoney < stations[currStation].c * i)
            {
                break;
            }
            int nextDestination;
            if(currStation + 1 >= n)
            {
                nextDestination = currKm + currGas + i;
            }
            else
            {
                nextDestination = stations[currStation + 1].x;
            }
            pair<int, int> curr = minTime(nextDestination, currMoney - stations[currStation].c * i, currGas + i - (nextDestination - currKm), max(waitingTime, stations[currStation].t * i), currStation + 1);
            if(curr.second < best.second)
            {
                best = curr;
            }
        }
    }
    else
    {
        return {10000000, c - currMoney};
    }
    return best;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> f >> p >> c;
    for(int i = 0; i < n; i++)
    {
        cin >> stations[i].x >> stations[i].t >> stations[i].c;
    }
    pair<int, int> res = minTime(stations[0].x, c, p - stations[0].x, 0, 0);
    cout << 0 << " " << res.second;
    return 0;
}
