#include <iostream>
using namespace std;
const int MAXN = 1e6 + 1;
int tree[MAXN * 4];
int kid[MAXN];
int arr[MAXN];
int ind[MAXN];
void build(int curr, int from, int to) {
    if (from == to) {
        tree[curr] = 1;
    } else {
        build(curr * 2, from, (from + to) / 2);
        build(curr * 2 + 1, (from + to) / 2 + 1, to);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }
}
int query(int curr, int from, int to, int r) {
    if (to <= r) {
        return tree[curr];
    }
    if (from <= r) {
        return (query(curr * 2, from, (from + to) / 2, r) + query(curr * 2 + 1, (from + to) / 2 + 1, to, r));
    }
    return 0;
}
void update(int curr, int from, int to, int target) {
    if (from <= target && target <= to) {
        tree[curr]--;
        if (from == to) {
            return;
        }
        update(curr * 2, from, (from + to) / 2, target);
        update(curr * 2 + 1, (from + to) / 2 + 1, to, target);
    }
}
int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);
    int n;
    cin >> n;
    int root;
    for (int i = 1; i <= n; i++) {
        int v;
        cin >> v;
        kid[v] = i;
        if (v == 0) {
            root = i;
        }
    }
    for (int i = 1; i <= n; i++) {
        arr[i] = root;
        root = kid[root];
    }
    for (int i = 1; i <= n; i++) {
        ind[arr[i]] = i;
    }
    build(1, 1, n);
    long long ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += query(1, 1, n, ind[i] - 1);
        update(1, 1, n, ind[i]);
    }
    cout << ans;
    return 0;
}

