#include <iostream>
#include <vector>
using namespace std;
const int MAXN = 5 * 1e3 + 1;
vector<int> neighbours[MAXN];
long long out = 0;
void dfs(int curr, int fa) {
    if (curr < fa) {
        out++;
    }
    for (auto it : neighbours[curr]) {
        dfs(it, fa);
    }
}
void calc(int curr) {
    dfs(curr, curr);
    for (auto it : neighbours[curr]) {
        calc(it);
    }
}

int main () {
    int n;
    cin >> n;
    int root;
    for (int i = 1; i <= n; i++) {
        int a;
        cin >> a;
        neighbours[a].push_back(i);
        if (a == 0) {
            root = i;
        }
    }
    calc(root);
    cout << out;
}

