#include<iostream>
#include<vector>
using namespace std;
const int MAXN = 1e5+7;
int par[MAXN];
bool used[MAXN];
vector<int> susedi[MAXN];
int koren;
int tree[4*MAXN];
int n;
void build_tree(int ind,int l,int r){
    if(l==r) tree[ind]=1;
    else{
        int m = (l+r)/2;
        build_tree(2*ind,l,m);
        build_tree(2*ind+1,m+1,r);
        tree[ind]=tree[2*ind]+tree[2*ind+1];
    }
}
void init(int N, std::vector< std::pair<int,int> > e){
    n=N;
    build_tree(1,1,e.size());
    /*for(auto [a,b]:e){
        susedi[b].push_back(a);
        susedi[a].push_back(b);
    }*/
    /*for(int i=1;i<=N;i++){
        cout<<par[i]<<" ";
    }*/
}
void update(int ind,int l,int r,int ql){
    if(l==r and l==ql){
        tree[ind]=0;
        return;
    }
    int m=(l+r)/2;
    if(ql<=m) update(2*ind,l,m,ql);
    if(ql>m) update(2*ind+1,m+1,r,ql);
    tree[ind]=tree[2*ind]+tree[2*ind+1];
}
int query(int ind,int l,int r,int ql,int qr){
    //cout<<ind<<" "<<l<<" "<<r<<" "<<ql<<" "<<qr<<" = "<<tree[ind]<<"\n";
    if(ql<=l and r<=qr){
        return tree[ind];
    }
    int ans = 0;
    int m = (l+r)/2;
    if(ql<=m) ans += query(2*ind,l,m,ql,qr);
    if(qr>m) ans += query(2*ind+1,m+1,r,ql,qr);
    return ans;
}
void close(int u,int v){
    if(u>v){
        swap(u,v);
    }
    update(1,0,n-1,u);
}

bool question(int u,int v){
    if(u>v) swap(u,v);
    int p = query(1,1,n-1,u,v);
    //cout<<"query = "<<p<<"\n";
    if(p<(v-u)) return false;
    return true;
}

