#include<bits/stdc++.h>
using namespace std;

const int maxn=1e3+32;
vector<int> nbrs[maxn];
bool ban[maxn][maxn];
bool vis[maxn];
int n;

void dfs(int x){
    vis[x]=true;

    for(auto j: nbrs[x]){
        if(!vis[j] and !ban[x][j] and !ban[j][x]){
            //cerr<<"going from "<<x<<" to "<<j<<endl;
             dfs(j);
        }
    }
    return ;
}

void init(int N, vector< pair<int,int> > e){
    for(int i=0; i<e.size(); i++){
        nbrs[e[i].first].push_back(e[i].second);
        nbrs[e[i].second].push_back(e[i].first);
        ban[e[i].second][e[i].first]=false;
        ban[e[i].first][e[i].second]=false;
    }

    for(int i=0; i<=N; i++){
        cout<<i<<": ";
        for(auto j: nbrs[i]){
            cout<<j<<" ";
        }
        cout<<endl;
    }

    for(int i=0; i<=N; i++){
        vis[i]=false;

    }
    n=N;


    return;
}

void close(int u,int v){
    ban[u][v]=true;
    ban[v][u]=true;

    return ;
}

bool question(int u,int v){
    for(int i=0; i<=n; i++){
        vis[i]=false;
    }
    dfs(u);

    return vis[v];
}

