#include<iostream>
#include<vector>
#include<set>
using namespace std;
set<int> graph[100002];
void Print()
{
     for(int i; i <3;i++)
        {
            cout<<i<<" - >";
          for(int child : graph[i])
            {
            cout<<child<<" ";	
            }
            cout<<endl;
    }
}

bool dfs(bool isVisited[100002], int node, int d)
{
    if(node==d)
    {
        return true;
    }
    
    if(isVisited[node])
    {
        return false;
    }
    
    isVisited[node]=true;
    
        for(auto child : graph[node])
        {
            bool f =dfs(isVisited, child ,d ); 
            //cout<<f<<endl;
            if(f==true)
            {
                return f;
            }
        }
    
    return false;
}

void init(int N, vector< std::pair<int,int> > e){

    for(pair<int, int> node : e)
    {
        graph[node.first].insert(node.second);
        graph[node.second].insert(node.first);
    }
    return;
}

void close(int u,int v){
    graph[u].erase(v);
    graph[v].erase(u);
}

bool question(int u,int v){
bool visited[100002];

    return  dfs(visited, u,v);
}