#include<bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse4")
#pragma GCC optimmize("Ofast")
const int maxn=1e6+1;
const int maxq=1e7+1;
int n;
std::vector<int>g[maxn];
int l[maxn],r[maxn];
int used[maxn];
void DFS(int u,int v)
{
    used[u]=1;
    int sz=g[u].size(),nb;
    for(int i=0; i<sz; i++)
    {
        nb=g[u][i];
        if(nb!=-1&&!used[nb])
        {
            DFS(nb,v);
        }
    }
}
void DFS2(int u,int b)
{
    used[u]=1;
    if(l[b]==0||l[b]>u)l[b]=u;
    if(r[b]<u)r[b]=u;
    int sz=g[u].size(),nb;
    for(int i=0; i<sz; i++)
    {
        nb=g[u][i];
        if(!used[nb])
        {
            DFS(nb,b);
            l[nb]=l[b];
            r[nb]=r[b];
            l[u]=l[b];
            r[u]=r[b];
        }
    }
}
/*void chain_obh(int u,int v)
{
    used[u]=1;
    int sz=g[u].size();
    if(u<v)
    {
        for(int i=0; i<sz; i++)
        {
            if(u<g[u][i])
            {
                chain_obh(g[u][i],v);
            }
        }
    }
    else if(u>v)
    {
        for(int i=0; i<sz; i++)
        {
            if(u>g[u][i])
            {
                chain_obh(g[u][i],v);
            }
        }
    }
}*/
void digleft(int i)
{
    used[i]=1;
    int sz=g[i].size();
    for(int j=0;j<sz;j++)
    {
        if(g[i][j]<i)
        {
            l[i]=g[i][j];
            digleft(g[i][j]);
        }
        l[g[i][j]]=l[i];
    }
}
void digright(int i)
{
    used[i]=1;
    int sz=g[i].size();
    for(int j=0;j<sz;j++)
    {
        if(g[i][j]>i)
        {
            r[i]=g[i][j];
            digright(g[i][j]);
        }
        r[g[i][j]]=r[i];
    }
}
void chain_init()
{
    for(int i=1; i<=n; i++)
    {
        if(!used[i])
        {
            DFS2(i,i);
            //digleft(i);
            //digright(i);
        }
        /*for(int j=l[i];j<=r[i];j++)
        {
            l[j]=l[i];
            r[j]=r[i];
            used[j]=1;
        }*/
    }
    /*for(int i=1; i<=n; i++)
    {
        int sz=g[i].size();
        for(int j=0; j<sz; j++)
        {
            if(l[i]==0||l[i]>g[i][j])l[i]=g[i][j];
            if(r[i]<g[i][j])r[i]=g[i][j];
        }
    }*/
    /*for(int i=1; i<=n; i++)
    {
        l[i]=1;
        r[i]=n;
    }*/
}
int flag;
void init(int N, std::vector< std::pair<int,int> > e)
{
    n=N;
    int sz=e.size();
    int u,v;
    for(int i=0; i<sz; i++)
    {
        u=e[i].first;
        v=e[i].second;
        g[v].push_back(u);
        g[u].push_back(v);
        if(v>u+1||v<u-1)flag=1;
    }
    if(!flag)chain_init();
    //check();
    return;
}
void close(int u,int v)
{
    if(flag==0)
    {
        if(u<v)
        {
            for(int i=l[u]; i<=u; i++)
            {
                if(r[i]>=u)r[i]=u;
            }
            for(int i=r[v]; i>=v; i--)
            {
                if(l[i]<=v)l[i]=u;
            }
        }
        else if(u>v)
        {
            for(int i=r[u]; i>=u; i--)
            {
                if(l[i]<=v)l[i]=u;
            }
            for(int i=l[v]; i<=v; i++)
            {
                if(r[i]>=u)r[i]=v;
            }
        }
    }
    else
    {
        int sz=g[u].size();
        for(int i=0; i<sz; i++)
        {
            if(g[u][i]==v)
            {
                g[u][i]=-1;
            }
        }
        sz=g[v].size();
        for(int i=0; i<sz; i++)
        {
            if(g[v][i]==u)
            {
                g[v][i]=-1;
            }
        }
    }
}
bool question(int u,int v)
{

    if(flag==1)
    {
        memset(used,0,sizeof(used));
        DFS(u,v);
        if(used[v])return true;
        return false;
    }
    else
    {
        if(u>=l[v]&&u<=r[v]&&v>=l[u]&&v<=r[u])return true;
        return false;
    }
}
